import gtk

class TreeViewUtilsFixed (object):
    @staticmethod
    def enable_renderer_editing_filterd (renderer, filter, attribute):
        model = filter.get_model()
        if 'editable' in renderer.props.__members__:
            renderer.props.editable = True

            def editing_started (renderer, editable, path):
                def editing_done (editable):
                    if isinstance (editable, gtk.Entry):
                        value = editable.props.text
                    elif isinstance (editable, gtk.SpinButton):
                        value = editable.props.value
                    elif isinstance (editable, gtk.ComboBoxEntry):
                        value = editable.child.props.text
                    # FIXME: elif isinstance (editable, gtk.ComboBox):
                    else:
                        raise TypeError ("unsupported gtk.Editable implementation %s.%s"
                                         % (editable.__module__, type (editable).__name__))

                    model_path = filter.convert_path_to_child_path(path)
                    model.set_cell (model.get_iter (model_path), attribute, value)

                editable.connect ('editing-done', editing_done)

            renderer.connect ('editing-started', editing_started)

        elif 'activatable' in renderer.props.__members__:
            def toggled (renderer, path):
                model_path = filter.convert_path_to_child_path(path)
                iter = model.get_iter (model_path)
                model.set_cell (iter, attribute, not model.get_cell (iter, attribute))

            renderer.connect ('toggled', toggled)

        else:
            raise TypeError ("unsupported gtk.CellRenderer implementation %s.%s"
                             % (renderer.__module__, type (renderer).__name__))